﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectStormtrooper.Drawnings;
/// <summary>
/// Сравнению по типу, скорости, весу
/// </summary>
public class DrawningStormtrooperBaseByType: IComparer<DrawningStormtrooperBase?>
{
    public int Compare(DrawningStormtrooperBase? x, DrawningStormtrooperBase? y)
    {
        if (x == null || x.EntityStormtrooperBase == null)
        {
            return 1;
        }
        if (y == null || y.EntityStormtrooperBase == null)
        {
            return -1;
        }
        if (x.GetType().Name != y.GetType().Name)
        {
            return x.GetType().Name.CompareTo(y.GetType().Name);
        }
        var speedCompare = x.EntityStormtrooperBase.Speed.CompareTo(y.EntityStormtrooperBase.Speed);
        if (speedCompare != 0)
        {
            return speedCompare;
        }
        return x.EntityStormtrooperBase.Weight.CompareTo(y.EntityStormtrooperBase.Weight);
    }
}
