﻿namespace ProjectStormtrooper.Entities;
/// <summary>
/// Класс-сущность "Штурмовик"
/// </summary>

public class EntityStormtrooperBase
{
    /// <summary>
    /// Скорость
    /// </summary>
    public int Speed { get; private set; }

    /// <summary>
    /// Вес
    /// </summary>
    public double Weight { get; private set; }

    /// <summary>
    /// Основной цвет
    /// </summary>
    /// 
    public Color BodyColor { get; private set; }
    public void SetBodyColor(Color bodyColor)
    {
        BodyColor = bodyColor;
    }
    // <summary>
    /// Шаг перемещения штурмовика
    /// </summary>
    public double Step => Speed * 100 / Weight;
    /// <summary>
    /// Конструктор сущности
    /// </summary>
    /// <param name="speed">Скорость</param>
    /// <param name="weight">Вес </param>
    /// <param name="bodyColor">Основной цвет</param>
    /// <param name="additionalColor">Дополнительный цвет</param>
    /// <param name="rockets">Признак наличия ракет</param>
    /// <param name="bombs">Признак наличия бомб</param>

    public EntityStormtrooperBase(int speed, double weight, Color bodyColor)
    {
        Speed = speed;
        Weight = weight;
        BodyColor = bodyColor;
        

    }
    /// <summary>
    /// Получение строк со значениями свойств объекта класса-сущности
    /// </summary>
    /// <returns></returns>
    public virtual string[] GetStringRepresentation()
    {
        return new[] { nameof(EntityStormtrooperBase), Speed.ToString(), Weight.ToString(), BodyColor.Name };
    }

    /// <summary>
    /// Создание объекта из массива строк
    /// </summary>
    /// <param name="strs"></param>
    /// <returns></returns>
    public static EntityStormtrooperBase? CreateEntityBaseStormtrooper(string[] strs)
    {
        if (strs.Length != 4 || strs[0] != nameof(EntityStormtrooperBase))
        {
            return null;
        }
        return new EntityStormtrooperBase(Convert.ToInt32(strs[1]), Convert.ToDouble(strs[2]), Color.FromName(strs[3]));
    }
}
